diff --git a/external/mambo/CVC b/external/mambo/CVC
new file mode 100644
index 0000000000000000000000000000000000000000..9dfba3c0467a1d76ac32cfce0d312496e9006b74
GIT binary patch
diff --git a/external/mambo/README.md b/external/mambo/README.md
index 0390cc0ab5b0..2196a2c3a6c6 100644
--- a/external/mambo/README.md
+++ b/external/mambo/README.md
@@ -53,6 +53,17 @@ export SKIBOOT=$HOME/src/skiboot/skiboot.lid
 export SKIBOOT_AUTORUN=1
 ```
 
+### Using Real Container Verification Code for Secure Boot
+
+The CVC code dump is from a real machine, and the code is from the Hostboot
+project (see src/securerom). We just include the dump here for testing
+purposes.
+
+```
+export SKIBOOT_CVC_CODE=$HOME/src/skiboot/external/mambo/CVC
+export SKIBOOT_ENABLE_MAMBO_STB=1
+```
+
 ### Run the simulator
 ```
 /opt/ibm/systemsim-p8/run/pegasus/power8 -f $HOME/src/skiboot/external/mambo/skiboot.tcl